;
; shellsort
;

.comment

here we go...

Shell sort specialized for 32 elements and display comparison

#define compGT(a,b) disp(a, b)

void shellSort(T *a)
{
  tblIndex n, h, i, j, hindex = 2;
  T t;
  int hVals[3] = {1, 4, 13};

   /**************************
    *  sort array a[lb..ub]  *
    **************************/

  do {
    h = hVals[hindex];

    /* sort-by-insertion in increments of h */
    i = h;
    do
    {
      t = a[i];
      j = i - h;
      if(compGT(a[j], t)) do
      {
        a[j + h] = a[j];
        j -= h;
      }while(j >= 0 && compGT(a[j], t));
      a[j+h] = t;
      i++;
    } while(i < 32);

    /* compute next increment */
    hindex--;
  } while(hindex >= 0);
}

.end

hValues
                .db 1, 4, 13
shellsort
                lda #2
                sta hIndex
---                             
                ldx hIndex      ;h = hvals[hindex]
                lda hValues,x
                sta h
                sta i           ;i = h
--                              ;do
                ldx i           ;t = a[i]
                lda rankings,x
                sta t
                txa             ;j = i - h
                sec
                sbc h
                sta j

                tax             ;if(compGT(a[j], t))
                lda rankings,x
                sta face2
;                lda t           ;the only use of t is face1 so i'm safe
;                sta face1

                jsr shellcompare
                bcc +

-
                ldx j
                lda rankings,x
                pha
                lda j
                clc
                adc h
                tax
                pla
                sta rankings,x
                lda j
                sec
                sbc h
                sta j
                bcc +           ;j < 0
                tax
                lda rankings,x
                sta face2
;                lda t           ;the only use of t is face1 so i'm safe
;                sta face1


;                jsr disp        ;the comparison function (real heavy duty)

                ;light duty comparison function
                jsr shellcompare


                bcs -
+
                lda j
                clc
                adc h
                tax
                lda t
                sta rankings,x

                inc i
                lda i
                cmp #32
                bcc --
                dec hindex
                bpl ---
                rts


;
; shellcompare
; Comparison function used in shellsort.
; If face2 is greater than face1, set carry.  Otherwise, clear carry.
;

